// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package freeje_admin

import (
	context "context"
	api "gitlab.com/BetaCompany/Freeje/sdk/go/api"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// TariffClient is the client API for Tariff service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type TariffClient interface {
	//
	// Непрерывно мониторить изменения в списке тарифов
	Monitor(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Tariff_MonitorClient, error)
	//
	// Получить список тарифов
	List(ctx context.Context, in *api.SearchFilter, opts ...grpc.CallOption) (Tariff_ListClient, error)
	//
	// Получить детали тарифа
	Get(ctx context.Context, in *AccountTariff, opts ...grpc.CallOption) (*AccountTariff, error)
	//
	// Обновить метаданный тарифа.
	Update(ctx context.Context, in *AccountTariff, opts ...grpc.CallOption) (*AccountTariff, error)
	//
	// Удалить тариф
	Delete(ctx context.Context, in *AccountTariff, opts ...grpc.CallOption) (*AccountTariff, error)
	//
	// Обновить данные стоимости направления в тарифе по префиксу.
	UpdatePrefix(ctx context.Context, in *PrefixTariff, opts ...grpc.CallOption) (*PrefixTariff, error)
	//
	// Удалить стоимость направления из тарифа
	DeletePrefix(ctx context.Context, in *PrefixTariff, opts ...grpc.CallOption) (*PrefixTariff, error)
	//
	// Получить список префиксов со стоимостью направления по тарифу.
	ListPrefix(ctx context.Context, in *AccountTariff, opts ...grpc.CallOption) (Tariff_ListPrefixClient, error)
	//
	// Получить список ограничений по тарифу.
	ListLimit(ctx context.Context, in *AccountTariff, opts ...grpc.CallOption) (Tariff_ListLimitClient, error)
	//
	// Обновить данные лимита в тарифе.
	UpdateLimit(ctx context.Context, in *LimitTariff, opts ...grpc.CallOption) (*LimitTariff, error)
	//
	// Удалить данные лимита из тарифа
	DeleteLimit(ctx context.Context, in *LimitTariff, opts ...grpc.CallOption) (*LimitTariff, error)
}

type tariffClient struct {
	cc grpc.ClientConnInterface
}

func NewTariffClient(cc grpc.ClientConnInterface) TariffClient {
	return &tariffClient{cc}
}

func (c *tariffClient) Monitor(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Tariff_MonitorClient, error) {
	stream, err := c.cc.NewStream(ctx, &Tariff_ServiceDesc.Streams[0], "/com.freeje.api.admin.Tariff/Monitor", opts...)
	if err != nil {
		return nil, err
	}
	x := &tariffMonitorClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Tariff_MonitorClient interface {
	Recv() (*AccountTariff, error)
	grpc.ClientStream
}

type tariffMonitorClient struct {
	grpc.ClientStream
}

func (x *tariffMonitorClient) Recv() (*AccountTariff, error) {
	m := new(AccountTariff)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *tariffClient) List(ctx context.Context, in *api.SearchFilter, opts ...grpc.CallOption) (Tariff_ListClient, error) {
	stream, err := c.cc.NewStream(ctx, &Tariff_ServiceDesc.Streams[1], "/com.freeje.api.admin.Tariff/List", opts...)
	if err != nil {
		return nil, err
	}
	x := &tariffListClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Tariff_ListClient interface {
	Recv() (*AccountTariff, error)
	grpc.ClientStream
}

type tariffListClient struct {
	grpc.ClientStream
}

func (x *tariffListClient) Recv() (*AccountTariff, error) {
	m := new(AccountTariff)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *tariffClient) Get(ctx context.Context, in *AccountTariff, opts ...grpc.CallOption) (*AccountTariff, error) {
	out := new(AccountTariff)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Tariff/Get", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *tariffClient) Update(ctx context.Context, in *AccountTariff, opts ...grpc.CallOption) (*AccountTariff, error) {
	out := new(AccountTariff)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Tariff/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *tariffClient) Delete(ctx context.Context, in *AccountTariff, opts ...grpc.CallOption) (*AccountTariff, error) {
	out := new(AccountTariff)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Tariff/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *tariffClient) UpdatePrefix(ctx context.Context, in *PrefixTariff, opts ...grpc.CallOption) (*PrefixTariff, error) {
	out := new(PrefixTariff)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Tariff/UpdatePrefix", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *tariffClient) DeletePrefix(ctx context.Context, in *PrefixTariff, opts ...grpc.CallOption) (*PrefixTariff, error) {
	out := new(PrefixTariff)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Tariff/DeletePrefix", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *tariffClient) ListPrefix(ctx context.Context, in *AccountTariff, opts ...grpc.CallOption) (Tariff_ListPrefixClient, error) {
	stream, err := c.cc.NewStream(ctx, &Tariff_ServiceDesc.Streams[2], "/com.freeje.api.admin.Tariff/ListPrefix", opts...)
	if err != nil {
		return nil, err
	}
	x := &tariffListPrefixClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Tariff_ListPrefixClient interface {
	Recv() (*PrefixTariff, error)
	grpc.ClientStream
}

type tariffListPrefixClient struct {
	grpc.ClientStream
}

func (x *tariffListPrefixClient) Recv() (*PrefixTariff, error) {
	m := new(PrefixTariff)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *tariffClient) ListLimit(ctx context.Context, in *AccountTariff, opts ...grpc.CallOption) (Tariff_ListLimitClient, error) {
	stream, err := c.cc.NewStream(ctx, &Tariff_ServiceDesc.Streams[3], "/com.freeje.api.admin.Tariff/ListLimit", opts...)
	if err != nil {
		return nil, err
	}
	x := &tariffListLimitClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Tariff_ListLimitClient interface {
	Recv() (*LimitTariff, error)
	grpc.ClientStream
}

type tariffListLimitClient struct {
	grpc.ClientStream
}

func (x *tariffListLimitClient) Recv() (*LimitTariff, error) {
	m := new(LimitTariff)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *tariffClient) UpdateLimit(ctx context.Context, in *LimitTariff, opts ...grpc.CallOption) (*LimitTariff, error) {
	out := new(LimitTariff)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Tariff/UpdateLimit", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *tariffClient) DeleteLimit(ctx context.Context, in *LimitTariff, opts ...grpc.CallOption) (*LimitTariff, error) {
	out := new(LimitTariff)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Tariff/DeleteLimit", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// TariffServer is the server API for Tariff service.
// All implementations should embed UnimplementedTariffServer
// for forward compatibility
type TariffServer interface {
	//
	// Непрерывно мониторить изменения в списке тарифов
	Monitor(*api.RequestMode, Tariff_MonitorServer) error
	//
	// Получить список тарифов
	List(*api.SearchFilter, Tariff_ListServer) error
	//
	// Получить детали тарифа
	Get(context.Context, *AccountTariff) (*AccountTariff, error)
	//
	// Обновить метаданный тарифа.
	Update(context.Context, *AccountTariff) (*AccountTariff, error)
	//
	// Удалить тариф
	Delete(context.Context, *AccountTariff) (*AccountTariff, error)
	//
	// Обновить данные стоимости направления в тарифе по префиксу.
	UpdatePrefix(context.Context, *PrefixTariff) (*PrefixTariff, error)
	//
	// Удалить стоимость направления из тарифа
	DeletePrefix(context.Context, *PrefixTariff) (*PrefixTariff, error)
	//
	// Получить список префиксов со стоимостью направления по тарифу.
	ListPrefix(*AccountTariff, Tariff_ListPrefixServer) error
	//
	// Получить список ограничений по тарифу.
	ListLimit(*AccountTariff, Tariff_ListLimitServer) error
	//
	// Обновить данные лимита в тарифе.
	UpdateLimit(context.Context, *LimitTariff) (*LimitTariff, error)
	//
	// Удалить данные лимита из тарифа
	DeleteLimit(context.Context, *LimitTariff) (*LimitTariff, error)
}

// UnimplementedTariffServer should be embedded to have forward compatible implementations.
type UnimplementedTariffServer struct {
}

func (UnimplementedTariffServer) Monitor(*api.RequestMode, Tariff_MonitorServer) error {
	return status.Errorf(codes.Unimplemented, "method Monitor not implemented")
}
func (UnimplementedTariffServer) List(*api.SearchFilter, Tariff_ListServer) error {
	return status.Errorf(codes.Unimplemented, "method List not implemented")
}
func (UnimplementedTariffServer) Get(context.Context, *AccountTariff) (*AccountTariff, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (UnimplementedTariffServer) Update(context.Context, *AccountTariff) (*AccountTariff, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Update not implemented")
}
func (UnimplementedTariffServer) Delete(context.Context, *AccountTariff) (*AccountTariff, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}
func (UnimplementedTariffServer) UpdatePrefix(context.Context, *PrefixTariff) (*PrefixTariff, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdatePrefix not implemented")
}
func (UnimplementedTariffServer) DeletePrefix(context.Context, *PrefixTariff) (*PrefixTariff, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeletePrefix not implemented")
}
func (UnimplementedTariffServer) ListPrefix(*AccountTariff, Tariff_ListPrefixServer) error {
	return status.Errorf(codes.Unimplemented, "method ListPrefix not implemented")
}
func (UnimplementedTariffServer) ListLimit(*AccountTariff, Tariff_ListLimitServer) error {
	return status.Errorf(codes.Unimplemented, "method ListLimit not implemented")
}
func (UnimplementedTariffServer) UpdateLimit(context.Context, *LimitTariff) (*LimitTariff, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateLimit not implemented")
}
func (UnimplementedTariffServer) DeleteLimit(context.Context, *LimitTariff) (*LimitTariff, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteLimit not implemented")
}

// UnsafeTariffServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to TariffServer will
// result in compilation errors.
type UnsafeTariffServer interface {
	mustEmbedUnimplementedTariffServer()
}

func RegisterTariffServer(s grpc.ServiceRegistrar, srv TariffServer) {
	s.RegisterService(&Tariff_ServiceDesc, srv)
}

func _Tariff_Monitor_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.RequestMode)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(TariffServer).Monitor(m, &tariffMonitorServer{stream})
}

type Tariff_MonitorServer interface {
	Send(*AccountTariff) error
	grpc.ServerStream
}

type tariffMonitorServer struct {
	grpc.ServerStream
}

func (x *tariffMonitorServer) Send(m *AccountTariff) error {
	return x.ServerStream.SendMsg(m)
}

func _Tariff_List_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.SearchFilter)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(TariffServer).List(m, &tariffListServer{stream})
}

type Tariff_ListServer interface {
	Send(*AccountTariff) error
	grpc.ServerStream
}

type tariffListServer struct {
	grpc.ServerStream
}

func (x *tariffListServer) Send(m *AccountTariff) error {
	return x.ServerStream.SendMsg(m)
}

func _Tariff_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AccountTariff)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TariffServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Tariff/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TariffServer).Get(ctx, req.(*AccountTariff))
	}
	return interceptor(ctx, in, info, handler)
}

func _Tariff_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AccountTariff)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TariffServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Tariff/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TariffServer).Update(ctx, req.(*AccountTariff))
	}
	return interceptor(ctx, in, info, handler)
}

func _Tariff_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AccountTariff)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TariffServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Tariff/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TariffServer).Delete(ctx, req.(*AccountTariff))
	}
	return interceptor(ctx, in, info, handler)
}

func _Tariff_UpdatePrefix_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(PrefixTariff)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TariffServer).UpdatePrefix(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Tariff/UpdatePrefix",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TariffServer).UpdatePrefix(ctx, req.(*PrefixTariff))
	}
	return interceptor(ctx, in, info, handler)
}

func _Tariff_DeletePrefix_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(PrefixTariff)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TariffServer).DeletePrefix(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Tariff/DeletePrefix",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TariffServer).DeletePrefix(ctx, req.(*PrefixTariff))
	}
	return interceptor(ctx, in, info, handler)
}

func _Tariff_ListPrefix_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(AccountTariff)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(TariffServer).ListPrefix(m, &tariffListPrefixServer{stream})
}

type Tariff_ListPrefixServer interface {
	Send(*PrefixTariff) error
	grpc.ServerStream
}

type tariffListPrefixServer struct {
	grpc.ServerStream
}

func (x *tariffListPrefixServer) Send(m *PrefixTariff) error {
	return x.ServerStream.SendMsg(m)
}

func _Tariff_ListLimit_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(AccountTariff)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(TariffServer).ListLimit(m, &tariffListLimitServer{stream})
}

type Tariff_ListLimitServer interface {
	Send(*LimitTariff) error
	grpc.ServerStream
}

type tariffListLimitServer struct {
	grpc.ServerStream
}

func (x *tariffListLimitServer) Send(m *LimitTariff) error {
	return x.ServerStream.SendMsg(m)
}

func _Tariff_UpdateLimit_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(LimitTariff)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TariffServer).UpdateLimit(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Tariff/UpdateLimit",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TariffServer).UpdateLimit(ctx, req.(*LimitTariff))
	}
	return interceptor(ctx, in, info, handler)
}

func _Tariff_DeleteLimit_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(LimitTariff)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(TariffServer).DeleteLimit(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Tariff/DeleteLimit",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(TariffServer).DeleteLimit(ctx, req.(*LimitTariff))
	}
	return interceptor(ctx, in, info, handler)
}

// Tariff_ServiceDesc is the grpc.ServiceDesc for Tariff service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Tariff_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "com.freeje.api.admin.Tariff",
	HandlerType: (*TariffServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Get",
			Handler:    _Tariff_Get_Handler,
		},
		{
			MethodName: "Update",
			Handler:    _Tariff_Update_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _Tariff_Delete_Handler,
		},
		{
			MethodName: "UpdatePrefix",
			Handler:    _Tariff_UpdatePrefix_Handler,
		},
		{
			MethodName: "DeletePrefix",
			Handler:    _Tariff_DeletePrefix_Handler,
		},
		{
			MethodName: "UpdateLimit",
			Handler:    _Tariff_UpdateLimit_Handler,
		},
		{
			MethodName: "DeleteLimit",
			Handler:    _Tariff_DeleteLimit_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "Monitor",
			Handler:       _Tariff_Monitor_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "List",
			Handler:       _Tariff_List_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "ListPrefix",
			Handler:       _Tariff_ListPrefix_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "ListLimit",
			Handler:       _Tariff_ListLimit_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "admin/tariff.proto",
}
